#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_GrowthFund.h"
#include "FileEncrypt.h"
std::auto_ptr<M_GrowthFund> M_GrowthFund::msSingleton(nullptr);

int M_GrowthFund::GetCount()
{
	return (int)mMapData.size();
}

const M_GrowthFundData* M_GrowthFund::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_GrowthFundData>& M_GrowthFund::GetMapData()
{
	return mMapData;
}

void M_GrowthFund::Reload()
{
	mMapData.clear();
	Load();
}

void M_GrowthFund::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_GrowthFundData data;
		data.mID = element->IntAttribute("ID");
		data.mFundType = element->IntAttribute("FundType");
		data.mLevel = element->IntAttribute("Level");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		data.mGiftId = element->IntAttribute("GiftId");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_GrowthFund::Load()
{
	Load("../Config/M_GrowthFund.xml");
}

M_GrowthFund* M_GrowthFund::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_GrowthFund());
	}
	return msSingleton.get();
}
